POJ 3126 Prime Path 素数+最短路

来源:互联网 发布:广联达软件销售电话 编辑:程序博客网 时间:2024/06/06 00:46
题目大意是让你求素数x到素数y的最短路径距离,每次只能对素数中的一位数进行改变,每次改变1英镑,求最小花费。
则素数a-b相连当且仅当a与b有一位数字不同。从起点开始bfs,若终点可达,即得到答案,不可达则输出Impossible。
 
Prime Path
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 7281 Accepted: 4128

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

Source

Northwestern Europe 2006

 

 

#include <iostream>#include <string.h>#include <math.h>#include <queue>using namespace std;int isprime( int n){    int i,t;    t=sqrt(n+0.0);    for (i=2;i<=t;i++){        if (n%i==0) return -2;    }    return -1;}//prime:-1; not prime:-2; arrived:>=0;const int S=10050;int prime[S],f[S],w[4];int main(){    int i,T,x,y,tmp,a,b,c,d,t;    for (i=2;i<S;i++) prime[i]=isprime(i);    cin>>T;    while (T--){        cin>>x>>y;        memcpy(f,prime,S*sizeof(int));        f[x]=0;        queue<int> q;        q.push(x);        while (!q.empty()&&(f[y]==-1))        {            t=q.front();            tmp=t;            q.pop();            for (i=0;i<=3;i++) {w[i]=tmp%10;tmp/=10;}            //ge_wei            for (i=0;i<=9;i++)            {                tmp=i+10*w[1]+100*w[2]+1000*w[3];                if (f[tmp]==-1) {                    f[tmp]=f[t]+1;                    q.push(tmp);                }            }            //shi_wei            for (i=0;i<=9;i++)            {                tmp=w[0]+10*i+100*w[2]+1000*w[3];                if (f[tmp]==-1) {                    f[tmp]=f[t]+1;                    q.push(tmp);                }            }            for (i=0;i<=9;i++)            {                tmp=w[0]+10*w[1]+100*i+1000*w[3];                if (f[tmp]==-1) {                    f[tmp]=f[t]+1;                    q.push(tmp);                }            }            for (i=1;i<=9;i++)            {                tmp=w[0]+10*w[1]+100*w[2]+1000*i;                if (f[tmp]==-1) {                    f[tmp]=f[t]+1;                    q.push(tmp);                }            }        }        if (f[y]!=-1) cout<<f[y]<<endl;else cout<<"Impossible\n";    }    return 0;}


 

原创粉丝点击